#include <stdio.h>
#include <conio.h>
#include <assert.h>
#include "ListNode.h"

//--------------------------------------------------------------------------
// Example code
//--------------------------------------------------------------------------

//--------------------------------------------------------------------------
//	Basic example
//--------------------------------------------------------------------------
void Example1()
{
	TListN<int>		*pIterator;
	TListN<int>		*pListA=NULL;	// Empty list A.
	TListN<int>		*pListB=NULL;	// Empty list B.

	TListN<int>		A(10),B(2),C(3),D(4);		// Define datas.

	//	Add elements to list A.
	A.InsertAt( &pListA );				// Link A to list A
	B.InsertAt( &pListA );				// Link B to list A
	
	//	Display the list A
	printf("\n List A :");
	for( pIterator = pListA ; pIterator ; Advance( pIterator ) )
	{	
		printf("%d ", (int)*pIterator ); 
	}

	//	We add listA to listB.
	C.InsertAt( &pListB );				// Link C to list B
	D.InsertAt( &pListB );				// Link D to list B
	pListA->AddTo( &pListB );			// Concatenate listA and listB

	//	Display the list B
	printf("\n List B :");
	pIterator = pListB;
	while( pIterator )
	{
		printf("%d ", (int)*pIterator ); 
		Advance( pIterator );
	}

}

//--------------------------------------------------------------------------
//	Example of lights moving in a hierachial node structure.
//--------------------------------------------------------------------------

// Example definition of a light
typedef	struct	{			
	int		tag;						// tag number of the light.
	float	Pos[3],Color[3],Radius;		// Example datas...	
}	TLight;					

// Example definition of generic space part node.
class	TSNode {
public:
	int				 tag;				// tag number of the node.
	TListN<TLight>	*Lights;			// List of the lights in node.
	TListN<TSNode>	*Sons;				// List of sons of node.
	TSNode()		{ Sons = NULL; Lights = NULL; }
};		


void Example2()
{
	TSNode			Root;			
	TListN<TSNode>	n[10];
	TListN<TLight>	lights[5];		

	//	Names the lights and nodes for output.
	Root.tag	= -1;
	{	for(int i=0;i<10;i++)	n[i]().tag = i;		}
	{	for(int i=0;i< 5;i++)	lights[i]().tag = i;}
													// Build the tree as
													// Root
	n[0].InsertAt( &Root.Sons );					//	+  0
			n[1].InsertAt( &n[0]().Sons );			//	|  +---1
			n[2].InsertAt( &n[0]().Sons );			//	|  +---2
	n[3].InsertAt( &Root.Sons );					//	+--3
	n[4].InsertAt( &Root.Sons );					//	+--4
			n[5].InsertAt( &n[4]().Sons );			//     +---5
				n[6].InsertAt( &n[5]().Sons );		//         +---6
					n[7].InsertAt( &n[6]().Sons );	//         |   +---7
						n[8].InsertAt(&n[7]().Sons);//         |       +---8
				n[9].InsertAt( &n[5]().Sons );		//         +---9

	// Once the tree is created we can attach and move easily lights between nodes.
	// We attach lights
	lights[0].InsertAt( &Root.Lights   );
	lights[1].InsertAt( &n[3]().Lights );
	lights[2].InsertAt( &n[4]().Lights );
	lights[3].InsertAt( &n[4]().Lights );
	lights[4].InsertAt( &n[4]().Lights );

	//---------------------------------------------------------------------
	// Show the tree.
	//---------------------------------------------------------------------
	typedef struct {
		static void ShowTree( TSNode *n , int level )
		{
			// Examples of iterating.
			if( n != NULL )
			{
				// Show node and lights tags,
				{
					printf(" %*s Node %d	Lights-> ", level*2," ", n->tag );
					for( TListN<TLight> *pIt=n->Lights; pIt ; Advance( pIt ) )
						printf(" %d", pIt->Get().tag );
					printf("\n");						
				}
				// Show sons,
				{
					for( TListN<TSNode> *pIt=n->Sons; pIt ; Advance( pIt ) )
						ShowTree( &pIt->Get() , level+1 );
				}
			}
		}
	} local;

	printf("\n-------------\n");
	local::ShowTree( &Root , 0 ); getch();

	// Now we can move as much as we need.
	lights[3].InsertAt( &Root.Lights );		// Move light3 to root.
	lights[1].InsertAt( &Root.Lights );		// Move light1 to root.

	// We can move a complete list from a node to other.
	n[4]().Lights->AddTo( &n[5]().Lights );	// Move all the lights of node 4 to node 5.

	printf("\n-------------\n");
	local::ShowTree( &Root , 0 );
}

//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
void main()
{
	Example1();
	Example2();
	getch();
}